
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')
local Prefs = import('/lua/user/prefs.lua')





OI_old_CreateElements = CreateElements

function CreateElements()

	OI_old_CreateElements()
	
	--()((()-- add MouseWheel support for switching tech levels
    controls.constructionGroup.HandleEvent = function(self, event)
	    if event.Type == 'WheelRotation' then
	    	local iCurrentTechTab = GetCurrentTechTab()
	    	local bSuccess = false
	    	if event.WheelRotation > 0 then
	    		iSwitchDirection = 1
	    	else
	    		iSwitchDirection = -1
	    	end
	    	if Prefs.GetOption('oi_build_reversetechswitcher') == 0 then
	    		iSwitchDirection = 0 - iSwitchDirection
	    	end
	    	bSuccess = SetCurrentTechTab(iCurrentTechTab + iSwitchDirection)
	    	if bSuccess then
	    		import('/lua/ui/game/unitviewDetail.lua').Hide()
	    	end
	    end
	end
    --()((()--
    
end




---[[
function CreateEnhancementButton(parent, enhancementName, enhancement)
    local tempBmpName = ""
    local tempEntityID = currentSelection[1]:GetBlueprint()

    if enhancement.Slot == "Back" then
        tempBmpName = tempEntityID.BlueprintId .. "-b-" .. enhancement.Icon
    elseif enhancement.Slot == "LCH" then
        tempBmpName = tempEntityID.BlueprintId .. "-la-" .. enhancement.Icon
    elseif enhancement.Slot == "RCH" then
        tempBmpName = tempEntityID.BlueprintId .. "-ra-" .. enhancement.Icon
    elseif enhancement.Slot == "Shield" then
        tempBmpName = tempEntityID.BlueprintId .. "-" .. enhancement.Icon
    end

    tempBmpName = GetEnhancementButtonBmpName(tempEntityID.BlueprintId, tempBmpName)

    local bg = Bitmap(parent)   #todo put land/air/sea background here
    bg:SetSolidColor('black')
    bg.Width:Set(GameCommon.iconBmpWidth)
    bg.Height:Set(GameCommon.iconBmpHeight)
    local button = Button(bg,
        UIUtil.UIFile(tempBmpName .. '_btn_up.dds'),
        UIUtil.UIFile(tempBmpName .. '_btn_over.dds'),
        UIUtil.UIFile(tempBmpName .. '_btn_down.dds'),
        UIUtil.UIFile(tempBmpName .. '_btn_sel.dds'),
        "UI_Enhancements_Click", "UI_Enhancements_Rollover")
    #LayoutHelpers.FillParent(button, bg)
    button.Top:Set(bg.Top)
    button.Left:Set(function() return bg.Left() + 1 end)
    if layoutVar == 'minimal' then
        button.Height:Set(48)
        button.Width:Set(48)
    end

    button.OnClick = function(self, modifiers)
        local orderData = {
            # UserVerifyScript='/lua/ui/game/EnhanceCommand.lua',
            TaskName = "EnhanceTask",
            Enhancement = enhancementName,
        }
        IssueCommand("UNITCOMMAND_Script", orderData, true)
        import('/lua/ui/game/enhancements.lua').ToggleDialog(filteredEnhancements, currentSelection[1], true)
    end

    button.HandleEvent = function(self, event)
        if event.Type == 'MouseEnter' then
            import('/lua/ui/game/unitviewDetail.lua').ShowEnhancement(enhancement, tempEntityID.BlueprintId, enhancement.Icon, currentSelection[1])
        end
        if event.Type == 'MouseExit' then
            import('/lua/ui/game/unitviewDetail.lua').Hide()
        end
        Button.HandleEvent(self, event)
    end
    button:UseAlphaHitTest(false)

	--()((()-- attach remove-icon if necessary
	if tempEntityID.Enhancements[enhancementName].RemoveEnhancements != nil then
		OIUtil.addRemoveIconTo(bg)
	end
	--()((()--

    return bg
end
--]]






function CreateBuildableButton(parent, blueprintId, blueprint, unitList)
    local iconName, upIconName, downIconName, overIconName = GameCommon.GetCachedUnitIconFileNames(blueprint)
    local bg = Group(parent)
    bg.Width:Set(GameCommon.iconBmpWidth)
    bg.Height:Set(GameCommon.iconBmpHeight)
    local button = Button(bg, upIconName, downIconName, overIconName, upIconName, 'UI_Opt_Mini_Button_Click', 'UI_Opt_Mini_Button_Over')
    button:UseAlphaHitTest(false)
    local selectedUnits = unitList
    button.Top:Set(bg.Top)
    button.Left:Set(function() return bg.Left() + 1 end)
    if layoutVar == 'minimal' then
        button.Height:Set(48)
        button.Width:Set(48)
    end
    button._blueprintId = blueprintId
    
    --()((()-- attach strat icon if possible
    OIUtil.addStrategicIconTo(button, blueprint)
    --()((()--

    if newTechUnits and table.find(newTechUnits, blueprintId) then
        table.remove(newTechUnits, table.find(newTechUnits, blueprintId))
        button.NewInd = Bitmap(button, UIUtil.UIFile('/game/selection/selection_brackets_player_highlighted.dds'))
        button.NewInd.Height:Set(80)
        button.NewInd.Width:Set(80)
        LayoutHelpers.AtCenterIn(button.NewInd, button)
        button.NewInd:DisableHitTest()
        button.NewInd.Incrementing = false
        button.NewInd:SetNeedsFrameUpdate(true)
        button.NewInd.OnFrame = function(self, delta)
            local newAlpha = self:GetAlpha() - delta / 5
            if newAlpha < 0 then
                self:SetAlpha(0)
                self:SetNeedsFrameUpdate(false)
                return
            else
                self:SetAlpha(newAlpha)
            end
            if self.Incrementing then
                local newheight = self.Height() + delta * 100
                if newheight > 80 then
                    self.Height:Set(80)
                    self.Width:Set(80)
                    self.Incrementing = false
                else
                    self.Height:Set(newheight)
                    self.Width:Set(newheight)
                end
            else
                local newheight = self.Height() - delta * 100
                if newheight < 50 then
                    self.Height:Set(50)
                    self.Width:Set(50)
                    self.Incrementing = true
                else
                    self.Height:Set(newheight)
                    self.Width:Set(newheight)
                end
            end
        end
    end

	--()((()-- disable crappy standard straticons
    --[[
    if (blueprint.StrategicIconName) then
        if DiskGetFileInfo(UIUtil.UIFile("/game/strategicicons/" .. string.lower(blueprint.StrategicIconName) .. "_rest.dds")) then
            button.Strat = Bitmap(button, UIUtil.UIFile("/game/strategicicons/" .. string.lower(blueprint.StrategicIconName) .. "_rest.dds"))
            button.Strat:DisableHitTest()
            LayoutHelpers.AtRightTopIn(button.Strat, button, 2, 2)
        end
    end
    --]]   
    --()((()--
    
    button.Glow = Bitmap(button)
    button.Glow:SetTexture(UIUtil.UIFile('/game/units_bmp/glow.dds'))
    #button.Glow:SetSolidColor('FF00FF00')
    #button.Glow.Height:Set(64)
    #button.Glow.Width:Set(64)
    LayoutHelpers.FillParent(button.Glow, button)
    button.Glow:SetAlpha(0)
    button.Incrementing = true
    button.Glow.OnFrame = function(self, elapsedTime)
        local curAlpha = self:GetAlpha()
        if self.Incrementing then
            curAlpha = curAlpha + (elapsedTime * GLOW_SPEED)
            if curAlpha > UPPER_GLOW_THRESHHOLD then
                curAlpha = UPPER_GLOW_THRESHHOLD
                self.Incrementing = false
            end
        else
            curAlpha = curAlpha - (elapsedTime * GLOW_SPEED)
            if curAlpha < LOWER_GLOW_THRESHHOLD then
                curAlpha = LOWER_GLOW_THRESHHOLD
                self.Incrementing = true
            end
        end
        self:SetAlpha(curAlpha)
    end

    local unitBuildKeys = import('/lua/ui/game/buildmode.lua').GetUnitKeys(selectedUnits[1]:GetBlueprint().BlueprintId, GetCurrentTechTab())
    if unitBuildKeys and unitBuildKeys[blueprint.BlueprintId] then
        button.KeyBG = Bitmap(button)
        button.KeyBG:SetSolidColor('AA000000')
        button.KeyBG.Height:Set(function() return button.Height() / 2 end)
        button.KeyBG.Width:Set(function() return button.Width() / 2 end)
        button.KeyBG.Right:Set(button.Right)
        button.KeyBG.Bottom:Set(button.Bottom)
        button.KeyBG.Depth:Set(function() return button.Glow.Depth() + 1 end)
        
        button.Key = UIUtil.CreateText(button.KeyBG, unitBuildKeys[blueprint.BlueprintId], 18, "Arial")
        LayoutHelpers.AtCenterIn(button.Key, button.KeyBG)
        button.Key:SetColor('ffff9900')
        
        button.KeyBG:DisableHitTest(true)
        button.KeyBG:Hide()
        button.KeyBG.OnHide = function(self)
            if import('/lua/ui/game/buildmode.lua').IsInBuildMode() then
                return false
            else
                return true
            end
        end
    end
    
    button.OnClick = function(self, modifiers)
        local blueprint = __blueprints[self._blueprintId]
        local count = 1
        local performUpgrade = false
        local buildCmd = "build"

        
        #for i,v in selectedUnits do
			#if EntityCategoryContains(categories.BUILDANCHORED,v) then
				#buildCmd = "buildanchored"
				#break
			#end
        #end

        selectedwhatIfBuilder = whatIfBuilder
        selectedwhatIfBlueprintID = whatIfBlueprintID

        if modifiers.Left then
        
        	--()((()-- use custom values
            if modifiers.Ctrl == true and modifiers.Shift == nil then
                count = Prefs.GetOption('oi_build_ctrlvalue')
            elseif modifiers.Shift == true and modifiers.Ctrl == nil then
                count = Prefs.GetOption('oi_build_shiftvalue')
            elseif modifiers.Shift == true and modifiers.Ctrl == true then
                count = Prefs.GetOption('oi_build_ctrlshiftvalue')
            end
            --[[
            if modifiers.Ctrl == true and modifiers.Shift == nil then
                count = 5
            elseif modifiers.Shift == true and modifiers.Ctrl == nil then
                count = 5
            elseif modifiers.Shift == true and modifiers.Ctrl == true then
                count = 5
            end
            --]]
            --()((()--

            # see if we are issuing an upgrade order
            if blueprint.General.UpgradesFrom == 'none' then
                performUpgrade = false
            else
                for i,v in selectedUnits do
                    if v then   # it's possible that your unit will have died by the time this gets to it
                        local unitBp = v:GetBlueprint()
                        if blueprint.General.UpgradesFrom == unitBp.BlueprintId then
                            performUpgrade = true
                        elseif blueprint.General.UpgradesFrom == unitBp.General.UpgradesTo then
                            performUpgrade = true
                        elseif blueprint.General.UpgradesFromBase != "none" then
                            # try testing against the base
                            if blueprint.General.UpgradesFromBase == unitBp.BlueprintId then
                                performUpgrade = true
                            elseif blueprint.General.UpgradesFromBase == unitBp.General.UpgradesFromBase then
                                performUpgrade = true
                            end
                        end                        
                    end
                end
            end

            if performUpgrade then
                # if the item to build is an upgrade.. then issue the upgrade command
                local clear = false
                
                # I don't think this is needed anymore, since commanders use the enhancement system, not upgrades. 
                # Please do not turn this back on without talking to dteh.
                #if blueprint.Physics.MotionType == 'RULEUMT_None' or modifiers.Shift then
                #    clear = false
                #end
                
                IssueBlueprintCommand("UNITCOMMAND_Upgrade", self._blueprintId, 1, clear)
            else
                if blueprint.Physics.MotionType == 'RULEUMT_None' or EntityCategoryContains(categories.NEEDMOBILEBUILD, self._blueprintId) then
                    # stationary means it needs to be placed, so go in to build mobile mode
					import('/lua/ui/game/commandmode.lua').StartCommandMode(buildCmd, {name=self._blueprintId})
                else
                    # if the item to build can move, it must be built by a factory
                    #TODO -what about mobile factories?
                    IssueBlueprintCommand("UNITCOMMAND_BuildFactory", self._blueprintId, count)
                end
            end
        else
            import('/lua/ui/game/queue.lua').RemovedLastQueuedUnit(self._blueprintId)
        end
    end

    button.HandleEvent = function(self, event)
        if event.Type == 'MouseEnter' then
            self.Glow:SetNeedsFrameUpdate(true)
            self.Glow:SetAlpha(LOWER_GLOW_THRESHHOLD)
            local blueprint = __blueprints[self._blueprintId]
            local builder = unitList[1]
            whatIfBuilder = builder
            whatIfBlueprintID = self._blueprintId
            Tooltip.CreateMouseoverDisplay(self, blueprint.Description)
            import('/lua/ui/game/unitviewDetail.lua').Show(blueprint, builder, self._blueprintId)
        end
        if event.Type == 'MouseExit' then
            self.Glow:SetNeedsFrameUpdate(false)
            self.Glow:SetAlpha(0)
            whatIfBuilder = nil
            whatIfBlueprintID = nil
            Tooltip.DestroyMouseoverDisplay()
            import('/lua/ui/game/unitviewDetail.lua').Hide()
        end
        Button.HandleEvent(self, event)
    end
    bg.button = button
    return bg
end



--()((()-- pass clear param through
function EnhancementPopulate(slot, bClear)
    local filteredEnhancements = {}
    for i, v in filteredTechTable[5] do
        if v['Slot'] == slot then
            filteredEnhancements[i] = v
        end
    end
    techLevelSelected = filteredEnhancements
    buildingEnhancements = true
    PopulateGridButtons(slot, bClear)
end

--()((()-- enhancement counter
iNumEnhancements = 1

--()((()-- add clear param
function PopulateGridButtons(inSlot, bClear)
	--()((()-- only clear when necessary
	if bClear == nil then
		bClear = true
	end
	if bClear then
		controls.unitGrid:DeleteAndDestroyAll(true)
	    ClearSessionExtraSelectList()
  	end
  	--[[
    controls.unitGrid:DeleteAndDestroyAll(true)
    ClearSessionExtraSelectList()
    --]]
    --()((()--
    if GameMain.gameUIHidden then return end
    
    if enhancementBool then
        controls.enhanceButton:Enable()
    else
        controls.enhanceButton:Disable()
        --()((()-- dont show button
        controls.enhanceButton:Hide()
        --()((()--
    end

    local totalCount = 0
    currentSelection = ValidateUnitsList(currentSelection)    
    if table.getn(currentSelection) >= 1 then
        # Check for setting up the transport content list
        if tempBuildableCategories then
            if EntityCategoryEmpty(tempBuildableCategories) and not buildingEnhancements then
                local userUnitList = GetAttachedUnitsList(currentSelection)
                totalCount = table.getn(userUnitList)
                if totalCount > 0 then
                    local visCols, visRows = controls.unitGrid:GetVisible()
                    controls.unitGrid:AppendCols(visCols, true)
                    controls.unitGrid:AppendRows(math.ceil(table.getn(userUnitList) / visCols), true)
        
                    for i,v in userUnitList do
                            local blueprintID = v:GetBlueprint().BlueprintId
                            local blueprint = __blueprints[blueprintID]
                            local button = CreateAttachedEntityButton(controls.unitGrid, blueprintID, blueprint, v)
                            local col = math.mod(i - 1, visCols) + 1 # note the sub/add due to one based arrays
                            local row = math.ceil(i / visCols)
                            controls.unitGrid:SetItem(button, col, row, true)
                    end
                end
            # Check for setting up the buildable categories list
            else
                local assistList = GetAssistingUnitsList(currentSelection)
                local entityCount = GetTableSize(techLevelSelected)
                totalCount = entityCount + table.getn(assistList)
                if UIUtil.currentLayout == 'minimal' then
                        controls.unitsBGCapMax.Right:Set(function() return math.min(controls.unitGrid.Left() + (48 * (totalCount+1) - 20), GetFrame(0).Right() - controls.unitsBGCapMax.BitmapWidth()) end)
                end
                local visCols, visRows = controls.unitGrid:GetVisible()
                controls.unitGrid:AppendCols(visCols, true)
                controls.unitGrid:AppendRows(math.ceil(totalCount / visCols), true)
        
                if buildingEnhancements then
                    local tempEntityID = currentSelection[1]:GetEntityId()
                    local existingEnhancements = import('/lua/enhancementcommon.lua').GetEnhancements(tempEntityID)
                    --()((()-- only reset when necessary
                    if bClear then
                    	-- reset
                    	iNumEnhancements = 1
                    else 
                    	-- do nothing
                    end
                    --local index = 1
                    --()((()
                    local restrictedList = import('/lua/enhancementcommon.lua').GetRestricted()
                    for i, v in techLevelSelected do
                        local isRestricted = false
                        if restrictedList then
                            for h, x in restrictedList do
                                if x == i then
                                    isRestricted = true
                                    break
                                end
                            end
                        end
                        --()((()-- various adjustments for enhancements
                        if not isRestricted then
                            if existingEnhancements == nil then
                                if v['Prerequisite'] == nil then
                                    local button = CreateEnhancementButton(controls.unitGrid, i, v)
                                    local col = math.mod(iNumEnhancements - 1, visCols) + 1 # note the sub/add due to one based arrays
                                    local row = math.ceil(iNumEnhancements / visCols)
                                    controls.unitGrid:SetItem(button, col, row, true)
                                    iNumEnhancements = iNumEnhancements + 1
                                    --index = index + 1
                                end
                            else
                                if existingEnhancements[inSlot] != nil then
                                    if existingEnhancements[inSlot] == v["Prerequisite"] then
                                        local button = CreateEnhancementButton(controls.unitGrid, i, v)
                                        local col = math.mod(iNumEnhancements - 1, visCols) + 1 # note the sub/add due to one based arrays
                                        local row = math.ceil(iNumEnhancements / visCols)
                                        controls.unitGrid:SetItem(button, col, row, true)
                                        iNumEnhancements = iNumEnhancements + 1
                                        --index = index + 1
                                    end
                                else
                                    if v['Prerequisite'] == nil then
                                        local button = CreateEnhancementButton(controls.unitGrid, i, v)
                                        local col = math.mod(iNumEnhancements - 1, visCols) + 1 # note the sub/add due to one based arrays
                                        local row = math.ceil(iNumEnhancements / visCols)
                                        controls.unitGrid:SetItem(button, col, row, true)
                                        iNumEnhancements = iNumEnhancements + 1
                                        --index = index + 1
                                    end
                                end
                            end
                        end
                        --()((()--
                    end
                else
                    if totalCount> 0 then
                        for i,v in techLevelSelected do
                            local blueprint = __blueprints[v]
                            local button = CreateBuildableButton(controls.unitGrid, v, blueprint, currentSelection)
                            local col = math.mod(i - 1, visCols) + 1 # note the sub/add due to one based arrays
                            local row = math.ceil(i / visCols)
                            controls.unitGrid:SetItem(button, col, row, true)
                        end
#                        for i,v in assistList do
#                            local index = entityCount + i
#                            local blueprintID = v:GetBlueprint().BlueprintId
#                            local blueprint = __blueprints[blueprintID]
#                            local button = CreateAssistingEntityButton(controls.unitGrid, blueprintID, blueprint, v)
#                            local col = math.mod(index - 1, visCols) + 1 # note the sub/add due to one based arrays
#                            local row = math.ceil(index / visCols)
#                            controls.unitGrid:SetItem(button, col, row, true)
#                        end
                    end
                end
            end
            controls.unitGrid:EndBatch()
        
            # Determine the check status of the "infinite loop" button
            local onlyFactories = true
            currentInfiniteQueueCheckStatus = false
        
            for i,v in currentSelection do
                if v:IsRepeatQueue() then
                    currentInfiniteQueueCheckStatus = true
                end
                if not v:IsInCategory('FACTORY') then
                    onlyFactories = false
                end
            end
        
            if onlyFactories then
                Queue.SetInfiniteQueueToggle(true)
                Queue.SetInfinityCheck(currentInfiniteQueueCheckStatus)
            else
                Queue.SetInfinityCheck(false)
            end
        
            local visCols, visRows = controls.unitGrid:GetVisible()
            --()((()-- also check for enhancements
            --LOG('enh:'..iNumEnhancements)
            --LOG('tcn:'..totalCount)
            --LOG('col:'..visCols)
            --LOG('row:'..visRows)
            if totalCount >= (visCols * visRows) or iNumEnhancements >= (visCols * visRows) then
                controls.scrollUnitsBackButton:Enable()
                controls.scrollUnitsFwdButton:Enable()
            else
                controls.scrollUnitsBackButton:Disable()
                controls.scrollUnitsFwdButton:Disable()
            end
        end
    end
end



--------------------------------------------------------------------------------
-- disable tech buttons
function disableTechButtons()
	
	--LOG('OI: disabling tech buttons')
	
	controls.tech1Tab.checkbox:Disable()
	controls.tech2Tab.checkbox:Disable()
    controls.tech3Tab.checkbox:Disable()
    controls.tech4Tab.checkbox:Disable()
    
    --enhancementBool = false
	controls.enhanceButton:Disable()
	controls.enhanceButton:Hide()


end