


function ToggleDialog(enhancementTable, unitID, closeBool)
    if controls.dialog then 
        if closeBool or not controls.dialog:IsHidden() then
            if not controls.dialog:IsHidden() then
                import('/lua/ui/game/construction.lua').ToggleEnhancementWindow(false, controls.dialog)
                import('/lua/ui/game/queue.lua').ToggleEnhancementWindow(false, controls.dialog)
            end
            controls.dialog:Hide() 
        else
            local tempbp = unitID:GetBlueprint()
            controls.windowTitle:SetText(LOC(tempbp.Description))
            for i, v in controls.slotButtons do
                if controls.slotButtons[i] then
                    controls.slotButtons[i]:Destroy()
                    controls.slotButtons[i] = false
                end
            end
            
            --()((()--
            --controls.dialog:Show() 
            --import('/lua/modules/ui/game/construction.lua').ToggleEnhancementWindow(true, controls.dialog)
            --import('/lua/modules/ui/game/queue.lua').ToggleEnhancementWindow(true, controls.dialog)
            local blueprintID = unitID:GetBlueprint().BlueprintId
            local entityID = unitID:GetEntityId()
            local blueprint = unitID:GetBlueprint()
            
            controls.unitImage:SetTexture(UIUtil.UIFile('/dialogs/enhance-panel/'..blueprintID..'_bmp.dds'))
            
            if enhancementTable.Slots then
                for i, v in enhancementTable.Slots do
                    if controls.slotButtons[i] then 
                        controls.slotButtons[i]:Destroy()
                        controls.slotButtons[i] = {}
                    else
                        controls.slotButtons[i] = {}
                    end
                    controls.slotButtons[i] = Checkbox(controls.unitImage, GetSlotTextures(blueprintID, i))
                    local y = v['y']
                    local x = v['x']
                    local slotName = i
                    controls.slotButtons[i].SlotName = slotName
                    controls.slotButtons[i].UnitID = unitID
                    controls.slotButtons[i].Blueprint = blueprint
                    controls.slotButtons[i].EntityID = entityID
                    controls.slotButtons[i].ButtonID = i
                    #controls.slotButtons[i].Top:Set(function() return controls.unitImage.Top() + y end)
                    #controls.slotButtons[i].Left:Set(function() return controls.unitImage.Left() + x end)
                    LayoutHelpers.AtCenterIn(controls.slotButtons[i], controls.dialog)
                    controls.slotButtons[i]:UseAlphaHitTest(true)
                    controls.slotButtons[i].OnClick = function(self, modifiers)
                        if not self:IsChecked() then
                            import('/lua/ui/game/construction.lua').EnhancementPopulate(slotName)
                            for curIndex, curBtn in controls.slotButtons do
                                if self.ButtonID == curIndex then
                                    curBtn:SetCheck(true, true)
                                else
                                    curBtn:SetCheck(false, true)
                                end
                            end
                        end
                    end
                    controls.slotButtons[i].HandleEvent = function(self, event)
                        if event.Type == 'MouseEnter' then
                            local tempTable = DisplayText(blueprintID, self.Blueprint, self.SlotName, self.EntityID, self.UnitID)
                            if tempTable.Name != 'EMPTY' then
                                import('/lua/ui/game/unitviewDetail.lua').ShowEnhancement(DisplayText(blueprintID, self.Blueprint, self.SlotName, self.EntityID, self.UnitID))
                            end
                        elseif event.Type == 'MouseExit' then
                            import('/lua/ui/game/unitviewDetail.lua').Hide()
                        end
                        Checkbox.HandleEvent(self, event)
                    end
                end
            else
                WARN("Enhancement Window: No slots defined in blueprint!")
            end
            
            --()((()-- show all slots
            --[[
            if table.getsize(enhancementTable.Slots) == 1 then
                for i, v in controls.slotButtons do
                    if controls.slotButtons[i] then
                        controls.slotButtons[i]:Disable()
                    end
                end
                local tempSlotName = ""
                for i, v in enhancementTable.Slots do
                    tempSlotName = i
                end
                import('/lua/ui/game/construction.lua').EnhancementPopulate(tempSlotName)
            else
                for i, v in controls.slotButtons do
                    if controls.slotButtons[i] then
                        controls.slotButtons[i]:SetCheck(true)
                        import('/lua/ui/game/construction.lua').EnhancementPopulate(controls.slotButtons[i].ButtonID)
                        break
                    end
                end
            end
            --]]
            local constructionScript = import('/lua/ui/game/construction.lua')
            constructionScript.controls.unitGrid:DeleteAndDestroyAll(true)
	    	constructionScript.ClearSessionExtraSelectList()
	    	constructionScript.iNumEnhancements = 1
            local aKnownSlots = {
		    	'Shield',
		    	'RCH',
		    	'Back',
		    	'LCH',
		    }
		    for i, sSlot in aKnownSlots do
		    	constructionScript.EnhancementPopulate(sSlot, false)
		    end
            --()((()--
        end
    end
end


