
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')

function SetLayout(gameParent)

    local controls = import('/lua/ui/game/borders.lua').controls
    
    -- controls on the edges
    
    controls.bottom:SetTexture(OIUtil.getImage('blank'))
    controls.bottom.Bottom:Set(gameParent.Bottom)
    controls.bottom.Left:Set(gameParent.Left)
    controls.bottom.Right:Set(gameParent.Right)
    controls.bottom.Width:Set(function() return bottom.Right() - bottom.Left() end)
    controls.bottom.Height:Set(152)
    controls.bottom:SetRenderPass(UIUtil.UIRP_UnderWorld)
    
    controls.controlClusterGroup:SetRenderPass(UIUtil.UIRP_PostGlow)
    LayoutHelpers.FillParent(controls.controlClusterGroup, controls.bottom)
    
    controls.top:SetTexture(OIUtil.getImage('economy_bg'))
    controls.top.Top:Set(gameParent.Top)
    controls.top.Left:Set(gameParent.Left)
    controls.top.Right:Set(gameParent.Right)
    --controls.top.Height:Set(37)
    controls.top.Width:Set(function() return top.Right() - top.Left() end)
    
    LayoutHelpers.FillParent(controls.statusClusterGroup, controls.top)
    
    controls.left:SetTexture(OIUtil.getImage('blank'))
    controls.left.Top:Set(controls.top.Bottom)
    controls.left.Bottom:Set(controls.bottom.Top)
    controls.left.Left:Set(function() return gameParent.Left() - 2 end)
    controls.left.Height:Set(function() return controls.left.Bottom() - controls.left.Top() end)
    
    controls.right:SetTexture(OIUtil.getImage('blank'))
    controls.right.Top:Set(controls.top.Bottom)
    controls.right.Bottom:Set(controls.bottom.Top)
    controls.right.Right:Set(function() return gameParent.Right() + 2 end)
    controls.right.Height:Set(function() return controls.right.Bottom() - controls.right.Top() end)
    
    
    -- Borders
    
    controls.topOS:SetTexture(OIUtil.getImage('shadow_bottom'))
    controls.topOS.Left:Set(controls.left.Right)
    controls.topOS.Right:Set(controls.right.Left)
    controls.topOS.Top:Set(controls.top.Bottom())
    controls.topOS.Width:Set(function() return controls.left.Right() - controls.right.Left() end)
    --[[
    controls.bottomOS:SetTexture(OIUtil.getImage('shadow_top'))
    controls.bottomOS.Left:Set(controls.left.Right)
    controls.bottomOS.Right:Set(controls.right.Left)
    controls.bottomOS.Bottom:Set(controls.bottom.Top)
    controls.bottomOS.Width:Set(function() return controls.left.Right() - controls.right.Left() end)
    --]]
    controls.bottomLeftOS:Hide()
    controls.bottomRightOS:Hide()
    controls.leftOS:Hide()
    controls.rightOS:Hide()
    controls.topLeftOS:Hide()
    controls.topRightOS:Hide()
    controls.bottomOS:Hide()
    
    
    
    -- mapGroup
    
    if controls.mapGroupLeft then
        controls.mapGroupLeft.Left:Set(controls.left.Right)
        controls.mapGroupLeft.Top:Set(controls.top.Bottom)
        --controls.mapGroupLeft.Right:Set(function() return (controls.left.Right() - 3) + ((controls.right.Left() - controls.left.Right()) / 2) end)
        controls.mapGroupLeft.Right:Set(function() return gameParent.Right() / 2 - 1 end)
        controls.mapGroupLeft.Bottom:Set(controls.bottom.Top)
        
        --controls.mapGroupRight.Left:Set(function() return (controls.left.Right() + 3) + ((controls.right.Left() - controls.left.Right()) / 2) end)
        controls.mapGroupRight.Left:Set(function() return gameParent.Right() / 2 + 1 end)
        controls.mapGroupRight.Top:Set(controls.top.Bottom)
        controls.mapGroupRight.Right:Set(controls.right.Left)
        controls.mapGroupRight.Bottom:Set(controls.bottom.Top)
        
        controls.mapGroup.Left:Set(controls.mapGroupLeft.Left)
        controls.mapGroup.Top:Set(controls.mapGroupLeft.Top)
        controls.mapGroup.Right:Set(controls.mapGroupRight.Right)
        controls.mapGroup.Bottom:Set(controls.mapGroupLeft.Bottom)
    else
        controls.mapGroup.Left:Set(controls.left.Right)
        controls.mapGroup.Top:Set(controls.top.Bottom)
        controls.mapGroup.Right:Set(controls.right.Left)
        controls.mapGroup.Bottom:Set(controls.bottom.Top)
    end
end