
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap

function SetLayout()
    local controls = import('/lua/ui/game/construction.lua').controls
    local mfdControl = import('/lua/ui/game/construction.lua').mfdControl
    local ordersControl = import('/lua/ui/game/construction.lua').ordersControl
    local controlClusterGroup = import('/lua/ui/game/construction.lua').controlClusterGroup
    local queueControl = import('/lua/ui/game/construction.lua').queueControl
    
    controls.constructionGroup.Top:Set(function() return controlClusterGroup.Top() - 1 end)
    --controls.constructionGroup.Bottom:Set(controlClusterGroup.Bottom)
    controls.constructionGroup.Bottom:Set(function() return controlClusterGroup.Bottom() - 5 end)
    controls.constructionGroup.Left:Set(function() return mfdControl.Right() end)
    --controls.constructionGroup.Right:Set(ordersControl.Left)
    controls.constructionGroup.Right:Set(function() return ordersControl.Left() + 4 end)
    
    controls.constructionGroup.Mini = function(state)
        controls.constructionGroup:Show()
    end
	
    --controls.unitsBGCapMin:SetTexture(UIUtil.SkinnableFile('/game/units_bmp/unit-02_bmp_l.dds'))
    controls.unitsBGCapMin:SetTexture(OIUtil.getImage('build_h_left'), 2)
    LayoutHelpers.AtTopIn(controls.unitsBGCapMin, controls.constructionGroup, 1)
    LayoutHelpers.AtLeftIn(controls.unitsBGCapMin, controls.constructionGroup, 0)
    LayoutHelpers.ResetBottom(controls.unitsBGCapMin)
    LayoutHelpers.ResetRight(controls.unitsBGCapMin)

    --controls.unitsBGCapMax:SetTexture(UIUtil.SkinnableFile('/game/units_bmp/unit-02_bmp_r.dds'))
    controls.unitsBGCapMax:SetTexture(OIUtil.getImage('build_h_right'), 2)
    LayoutHelpers.AtTopIn(controls.unitsBGCapMax, controls.constructionGroup, 1)
    LayoutHelpers.AtRightIn(controls.unitsBGCapMax, controls.constructionGroup, 2)
    LayoutHelpers.ResetLeft(controls.unitsBGCapMax)
    LayoutHelpers.ResetBottom(controls.unitsBGCapMax)

    --controls.unitsBGMiddle:SetTexture(UIUtil.SkinnableFile('/game/units_bmp/unit-02_bmp_m.dds'))
    controls.unitsBGMiddle:SetTexture(OIUtil.getImage('build_h_bg'), 2)
    controls.unitsBGMiddle.Left:Set(controls.unitsBGCapMin.Right)
    controls.unitsBGMiddle.Right:Set(controls.unitsBGCapMax.Left)
    controls.unitsBGMiddle.Top:Set(controls.unitsBGCapMin.Top)
    --controls.unitsBGMiddle:SetTiled(true)
    controls.unitsBGMiddle:SetTiled(false)
    LayoutHelpers.ResetWidth(controls.unitsBGMiddle)
    LayoutHelpers.ResetBottom(controls.unitsBGMiddle)
    controls.unitsBGMiddle.Height:Set(controls.unitsBGMiddle.BitmapHeight)
    
    --!!! additional bitmaps
    controls.unitsBGTop = Bitmap(controls.constructionGroup)
    controls.unitsBGTop:SetTexture(OIUtil.getImage('build_h_top'), 2)
    LayoutHelpers.AtLeftTopIn(controls.unitsBGTop, controls.unitsBGCapMin, 0, -52)
    
    if not controls.shadowTop then
	    controls.shadowTop = Bitmap(controls.unitsBGTop, OIUtil.getImage('shadow_top'))
	    controls.shadowTop.Bottom:Set(function() return controls.unitsBGTop.Top() + 2 end)
	    controls.shadowTop.Left:Set(function() return controls.unitsBGTop.Left() end)
		controls.shadowTop.Right:Set(function() return controls.unitsBGTop.Right() end)
    end
    
    if not controls.shadowRight then
	    controls.shadowRight = Bitmap(controls.unitsBGTop, OIUtil.getImage('shadow_right'))
	    controls.shadowRight.Left:Set(function() return controls.unitsBGTop.Right() end)
	    controls.shadowRight.Top:Set(function() return controls.unitsBGTop.Top() + 2 end)
		controls.shadowRight.Bottom:Set(function() return controls.unitsBGTop.Top() + 52 end)
    end
    
    if not controls.shadowTopRight then 
	    controls.shadowTopRight = Bitmap(controls.unitsBGTop, OIUtil.getImage('shadow_topright'))
	    controls.shadowTopRight.Left:Set(function() return controls.unitsBGTop.Right() end)
	    controls.shadowTopRight.Bottom:Set(function() return controls.unitsBGTop.Top() + 2 end)
	end
	
	if not controls.shadowOSReplacment then 
	    controls.shadowOSReplacment = Bitmap(controls.unitsBGMiddle, OIUtil.getImage('shadow_top'))
	    controls.shadowOSReplacment.Bottom:Set(function() return controls.unitsBGMiddle.Top() end)
	    controls.shadowOSReplacment.Left:Set(function() return controls.unitsBGMiddle.Left() - 20 end)
	    controls.shadowOSReplacment.Right:Set(function() return controls.unitsBGMiddle.Right() + 20 end)
	end
    
    -- T1 tab
    
    controls.tech1Tab.checkbox:SetNewTextures(
            OIUtil.getImage('t1'),
            OIUtil.getImage('t1_mo'),
            OIUtil.getImage('t1_mo'),
            OIUtil.getImage('t1_mo'),
            OIUtil.getImage('t1_dis'),
            OIUtil.getImage('t1_dis'))
    LayoutHelpers.AtLeftTopIn(controls.tech1Tab.checkbox, controls.unitsBGCapMin, 7, -40)
    controls.tech1Tab.checkbox.Depth:Set(function() return controls.unitsBGMiddle.Depth() + 100 end)
    controls.tech1Tab.checkbox:Disable()
    
    LayoutHelpers.AtCenterIn(controls.tech1Tab.icon, controls.tech1Tab.checkbox, 0, -5)
    controls.tech1Tab.icon.Depth:Set(function() return controls.unitsBGMiddle.Depth() + 101 end)
    controls.tech1Tab.icon:DisableHitTest()
    controls.tech1Tab.icon:SetTexture(OIUtil.getImage('icon_t1'))
    --controls.tech1Tab.icon:Hide()



	-- T2 tab
    
    controls.tech2Tab.checkbox:SetNewTextures(
            OIUtil.getImage('t2'),
            OIUtil.getImage('t2_mo'),
            OIUtil.getImage('t2_mo'),
            OIUtil.getImage('t2_mo'),
            OIUtil.getImage('t2_dis'),
            OIUtil.getImage('t2_dis'))
    LayoutHelpers.AtLeftTopIn(controls.tech2Tab.checkbox, controls.unitsBGCapMin, 7, -10)
    controls.tech2Tab.checkbox.Depth:Set(function() return controls.tech1Tab.checkbox.Depth() + 1 end)
    controls.tech2Tab.checkbox:Disable()
    
    LayoutHelpers.AtCenterIn(controls.tech2Tab.icon, controls.tech2Tab.checkbox, 0, -5)
    controls.tech2Tab.icon.Depth:Set(function() return controls.tech1Tab.checkbox.Depth() + 20 end)
    controls.tech2Tab.icon:DisableHitTest()
    controls.tech2Tab.icon:SetTexture(OIUtil.getImage('icon_t2'))
	--controls.tech2Tab.icon:Hide()



    -- T3 tab
    
    controls.tech3Tab.checkbox:SetNewTextures(
            OIUtil.getImage('t3'),
            OIUtil.getImage('t3_mo'),
            OIUtil.getImage('t3_mo'),
            OIUtil.getImage('t3_mo'),
            OIUtil.getImage('t3_dis'),
            OIUtil.getImage('t3_dis'))
    LayoutHelpers.AtLeftTopIn(controls.tech3Tab.checkbox, controls.unitsBGCapMin, 7, 20)
    controls.tech3Tab.checkbox.Depth:Set(function() return controls.tech2Tab.checkbox.Depth() + 1 end)
    controls.tech3Tab.checkbox:Disable()

	LayoutHelpers.AtCenterIn(controls.tech3Tab.icon, controls.tech3Tab.checkbox, 0, -5)
    controls.tech3Tab.icon.Depth:Set(function() return controls.tech2Tab.checkbox.Depth() + 20 end)
    controls.tech3Tab.icon:DisableHitTest()
	controls.tech3Tab.icon:SetTexture(OIUtil.getImage('icon_t3'))
	--controls.tech3Tab.icon:Hide()
	


    -- T4 tab
    
    controls.tech4Tab.checkbox:SetNewTextures(
            OIUtil.getImage('t4'),
            OIUtil.getImage('t4_mo'),
            OIUtil.getImage('t4_mo'),
            OIUtil.getImage('t4_mo'),
            OIUtil.getImage('t4_dis'),
            OIUtil.getImage('t4_dis'))
    LayoutHelpers.AtLeftTopIn(controls.tech4Tab.checkbox, controls.unitsBGCapMin, 7, 50)
    controls.tech4Tab.checkbox.Depth:Set(function() return controls.tech3Tab.checkbox.Depth() + 1 end)
    controls.tech4Tab.checkbox:Disable()
    
    LayoutHelpers.AtCenterIn(controls.tech4Tab.icon, controls.tech4Tab.checkbox, 0, -5)
    controls.tech4Tab.icon.Depth:Set(function() return controls.tech1Tab.checkbox.Depth() + 20 end)
    controls.tech4Tab.icon:DisableHitTest()
    controls.tech4Tab.icon:SetTexture(OIUtil.getImage('icon_t4'))
    --controls.tech4Tab.icon:Hide()
    
    
    
    
    
    ---[[
    LayoutHelpers.FillParent(controls.tech2disabledOverGroup, controls.tech2Tab.checkbox) 
    controls.tech2disabledOverGroup.Depth:Set(function() return controls.tech2Tab.checkbox.Depth() + 5 end)
    
    LayoutHelpers.FillParent(controls.tech3disabledOverGroup, controls.tech3Tab.checkbox) 
    controls.tech3disabledOverGroup.Depth:Set(function() return controls.tech3Tab.checkbox.Depth() + 5 end)
    
    LayoutHelpers.FillParent(controls.tech4disabledOverGroup, controls.tech4Tab.checkbox) 
    controls.tech4disabledOverGroup.Depth:Set(function() return controls.tech4Tab.checkbox.Depth() + 5 end)
    --]]
    
    
    -- scroll buttons
    
    controls.scrollUnitsBackButton.Depth:Set(function() return controls.unitsBGCapMin.Depth() + 200 end)
    controls.scrollUnitsBackButton:Disable()
    controls.scrollUnitsBackButton:SetNewTextures(
    	OIUtil.getImage('scroll_left'),
        OIUtil.getImage('scroll_left'),
        OIUtil.getImage('scroll_left_mo'),
        OIUtil.getImage('scroll_left_dis')
    )
    LayoutHelpers.AtLeftTopIn(controls.scrollUnitsBackButton, controls.unitsBGCapMin, 103, 7)
    
    controls.scrollUnitsFwdButton.Depth:Set(function() return controls.scrollUnitsBackButton.Depth() + 1 end)
    controls.scrollUnitsFwdButton:Disable()
    controls.scrollUnitsFwdButton:SetNewTextures(
    	OIUtil.getImage('scroll_right'),
        OIUtil.getImage('scroll_right'),
        OIUtil.getImage('scroll_right_mo'),
        OIUtil.getImage('scroll_right_dis')
    )
    LayoutHelpers.AtRightTopIn(controls.scrollUnitsFwdButton, controls.unitsBGCapMax, 7, 7)

	

	-- enhance button

    --controls.enhanceButton.Bottom:Set(function() return controls.scrollUnitsBackButton.Top() + 0 end)
    --[[controls.enhanceButton:SetNewTextures(UIUtil.UIFile('/dialogs/enhance-panel_btn/infinite_btn_up.dds'),
        UIUtil.UIFile('/dialogs/enhance-panel_btn/infinite_btn_down.dds'),
        UIUtil.UIFile('/dialogs/enhance-panel_btn/infinite_btn_over.dds'),
        UIUtil.UIFile('/dialogs/enhance-panel_btn/infinite_btn_dis.dds'))--]]
    controls.enhanceButton:SetNewTextures(
    	OIUtil.getImage('upgrade'),
        OIUtil.getImage('upgrade'),
        OIUtil.getImage('upgrade_mo'),
        OIUtil.getImage('upgrade')
    )
    controls.enhanceButton.Height:Set(44)
    controls.enhanceButton.Width:Set(44)
    controls.enhanceButton.Bottom:Set(function() return controls.unitsBGTop.Top() + 53 end)
    controls.enhanceButton.Left:Set(function() return controls.unitsBGTop.Right() - 1 end)
    --controls.enhanceButton:SetTexture(UIUtil.UIFile('/dialogs/enhance-panel_btn/infinite_btn_up.dds'))
    --LayoutHelpers.AtRightTopIn(controls.enhanceButton, controls.unitsBGTop, -44, 5)
    
    LayoutHelpers.ResetTop(controls.enhanceButton)
	
	
	
    controls.unitGrid:Destroy()
    controls.unitGrid = Grid(controls.unitsBGMiddle, 62, 62)
    
    controls.unitGrid.Left:Set(function() return controls.unitsBGMiddle.Left() - 6 end)
    controls.unitGrid.Right:Set(function() return controls.unitsBGMiddle.Right() - 10 end)
    --controls.unitGrid.Height:Set(function() return 64 * 2 end)
    controls.unitGrid.Height:Set(64)
    LayoutHelpers.AtVerticalCenterIn(controls.unitGrid, controls.unitsBGMiddle, -4)
    LayoutHelpers.ResetWidth(controls.unitGrid)
end