
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')

function CreateControls(controls)
    if controls.genBG then
        controls.genBG:Destroy()
        controls.genBG = false
        controls.genBGL = false
        controls.genBGR = false
        controls.genBGM = false
        controls.massMini = false
        controls.energyMini = false
    end
    
    if not controls.group then
        controls.group = Group(parent, "economyBarGroup")
        controls.group:DisableHitTest()
    end
    
    -- mass setup
    if not controls.massBG then
    	controls.massBG = Bitmap(controls.group)
    	--controls.massBG:SetTexture(OIUtil.getImage('economy_left'), 0)
    end
    controls.massBG:SetTexture(OIUtil.getImage('economy_left'), 0)
    
    if controls.massDropdown then controls.massDropdown:Destroy() controls.massDropdown = false end
    if not controls.massDropdown then
        controls.massDropdown = Bitmap(controls.massBG)
        controls.massDropdown:SetTexture(OIUtil.getImage('resource_rate_advanced'), 0)
    end
    
    if not controls.massDropOver then
        controls.massDropOver = Bitmap(controls.massBG)
        controls.massDropOver:SetTexture(OIUtil.getImage('resource_rate_advanced_mo'), 0)
    end

    if not controls.massIncome then
        controls.massIncome = UIUtil.CreateText(controls.group, "", 10, UIUtil.fixedFont)
    end

    if not controls.massExpense then
        controls.massExpense = UIUtil.CreateText(controls.group, "", 10, UIUtil.fixedFont)
    end
    
    if not controls.massLabel then
        controls.massLabel = Bitmap(controls.massBG)
        controls.massLabel:SetTexture(OIUtil.getImage('mass_label'), 0)
    end

    if controls.massStatus then controls.massStatus:Destroy() controls.massStatus = false end
    if not controls.massStatus then
        controls.massStatus = StatusBar(controls.massBG, 0, 100, false, false, OIUtil.getImage('mass_bar_bg'), OIUtil.getImage('mass_bar'), false)
    end
    
    
    if not controls.massRateContainer then
         controls.massRateContainer = Button(controls.massBG, 
            OIUtil.getImage('resource_rate'),
            OIUtil.getImage('resource_rate_mo'),
            OIUtil.getImage('resource_rate_mo'),
            OIUtil.getImage('resource_rate_mo'),
            "UI_Economy_Click", "UI_Economy_Rollover")
    end
    
    if not controls.massRate then
        controls.massRate = UIUtil.CreateText(controls.group, "", 20, UIUtil.bodyFont)
    end
    
    if not controls.massWarning then
        --controls.massWarning = UIUtil.CreateText(controls.group, LOC("<LOC Econ_0000>Mass Needed"), 16, UIUtil.titleFont)   
    	controls.massWarning = Bitmap(controls.massBG, OIUtil.getImage('economy_warning_negative'))
    end
    
    if not controls.massPosWarning then
        --controls.massPosWarning = Bitmap(controls.massBG, OIUtil.getImage('economy_warning_positive'))
    end
    
    --if not controls.massWarningBG then
        --controls.massWarningBG = Bitmap(controls.massBG, UIUtil.UIFile('/game/orders/glow-02_bmp.dds'))
        --controls.massWarningBG = Bitmap(controls.group, OIUtil.getImage('blank'))
    --end
        
    -- this exists only to act as a hit target for the dropdown data
    if not controls.massDropdownTarget then
        controls.massDropdownTarget = Group(controls.massBG, "massDropdown")
    end
    
    if controls.massStorage then controls.massStorage:Destroy() controls.massStorage = false end
    if not controls.massStorage then
        controls.massStorage = UIUtil.CreateText(controls.group, "", 12, UIUtil.bodyFont)
    end




    -- energy bar setup
    if not controls.energyBG then
        --controls.energyBG = Bitmap(controls.group, UIUtil.UIFile('/game/resources/energy-back_bmp.dds'))
        controls.energyBG = Bitmap(controls.group)
        --controls.energyBG:SetTexture(OIUtil.getImage('economy_right'), 0)
    end
    controls.energyBG:SetTexture(OIUtil.getImage('economy_right'), 0)

    if controls.energyDropdown then controls.energyDropdown:Destroy() controls.energyDropdown = false end
    if not controls.energyDropdown then
        controls.energyDropdown = Bitmap(controls.energyBG)
        controls.energyDropdown:SetTexture(OIUtil.getImage('resource_rate_advanced'), 0)
    end
    
    if not controls.energyDropOver then
        controls.energyDropOver = Bitmap(controls.energyBG)
        controls.energyDropOver:SetTexture(OIUtil.getImage('resource_rate_advanced_mo'), 0)
    end

    if not controls.energyIncome then
        controls.energyIncome = UIUtil.CreateText(controls.group, "", 10, UIUtil.fixedFont)
    end
   
    if not controls.energyExpense then
        controls.energyExpense = UIUtil.CreateText(controls.group, "", 10, UIUtil.fixedFont)
    end

    if not controls.energyLabel then
        controls.energyLabel = Bitmap(controls.energyBG)
        controls.energyLabel:SetTexture(OIUtil.getImage('energy_label'), 0)
    end

    if controls.energyStatus then controls.energyStatus:Destroy() controls.energyStatus = false end
    if not controls.energyStatus then
        controls.energyStatus = StatusBar(controls.energyBG, 0, 100, false, false, OIUtil.getImage('energy_bar_bg'), OIUtil.getImage('energy_bar'), false)
    end
    
    if controls.energyStorage then controls.energyStorage:Destroy() controls.energyStorage = false end
    if not controls.energyStorage then
        controls.energyStorage = UIUtil.CreateText(controls.group, "", 12, UIUtil.bodyFont)
    end
    
    if not controls.energyRateContainer then
        controls.energyRateContainer = Button(controls.energyBG,
            OIUtil.getImage('resource_rate'),
            OIUtil.getImage('resource_rate_mo'),
            OIUtil.getImage('resource_rate_mo'),
            OIUtil.getImage('resource_rate_mo'),
            "UI_Economy_Click", "UI_Economy_Rollover")
    end
        
    if not controls.energyRate then
        controls.energyRate = UIUtil.CreateText(controls.group, "", 20, UIUtil.bodyFont)
    end

    if not controls.energyWarning then
        --controls.energyWarning = UIUtil.CreateText(controls.group, LOC("<LOC Econ_0001>Energy Needed"), 16, UIUtil.titleFont)
    	controls.energyWarning = Bitmap(controls.group, OIUtil.getImage('economy_warning_negative'))
    end
    
    if not controls.energyPosWarning then
        --controls.energyPosWarning = Bitmap(controls.group, OIUtil.getImage('economy_warning_positive'))
    end
    
    --if not controls.energyWarningBG then
        --controls.energyWarningBG = Bitmap(controls.energyBG, UIUtil.UIFile('/game/orders/glow-02_bmp.dds'))
        --controls.energyWarningBG = Bitmap(controls.group, OIUtil.getImage('blank'))
    --end
    
    -- this exists only to act as a hit target for the dropdown data
    if not controls.energyDropdownTarget then
        controls.energyDropdownTarget = Group(controls.energyBG, "energyDropdown")
    end
end


function SetLayout()

    local controls = import('/lua/ui/game/economy.lua').controls

    CreateControls(import('/lua/ui/game/economy.lua').controls)
	
	-- ...BG			background for whole group
	-- ...Label			resource icon
	-- ...
	
	-- ...Rate			basic display income/expense text
	-- ...RateContainer	basic display income/expense bg
	-- ...Status		basic display statusbar
	-- ...Storage		basic display storage text
	-- ...Warning		basic display warning text
	-- ...WarningBG		basic display warning bg
	
	-- ...Dropdown		advanced display bg
	-- ...DropOver		advanced display mousover bg
	-- ...Income		advanced display income
	-- ...Expense		advanced display expense
	
	--parent.Bottom = 37
	LayoutHelpers.FillParent(controls.group, parent)
	
	----------------------------------------------------------------------------
	-- mass setup
	----------------------------------------------------------------------------
	
	-- 1st level placement
    LayoutHelpers.AtLeftTopIn(controls.massBG, controls.group, 0, 0)
    LayoutHelpers.AtLeftTopIn(controls.massLabel, controls.massBG, 3, 3)
    LayoutHelpers.AtLeftTopIn(controls.massStatus, controls.massBG, 42, 7)
    LayoutHelpers.AtLeftTopIn(controls.massRateContainer, controls.massBG, 237, 4)
    LayoutHelpers.AtLeftTopIn(controls.massDropdown, controls.massBG, 304, 3)
    LayoutHelpers.AtCenterIn(controls.massWarning, controls.massLabel, 0, 0)
    
    -- 2nd level placement
    LayoutHelpers.AtLeftTopIn(controls.massDropOver, controls.massDropdown, 0, 0)
    LayoutHelpers.AtCenterIn(controls.massRate, controls.massRateContainer)
    LayoutHelpers.AtCenterIn(controls.massIncome, controls.massDropdown, -6, 0)
    LayoutHelpers.AtCenterIn(controls.massExpense, controls.massDropdown, 6, 0)
    controls.massExpense:SetColor(OIUtil.getColor('economy_expense'))
    controls.massIncome:SetColor(OIUtil.getColor('economy_income'))
    LayoutHelpers.CenteredBelow(controls.massStorage, controls.massStatus, 0)
    
    ---[[
    -- dynamic placement
    --controls.massRateContainer.Left:Set(function() return controls.massStatus.Right() + 2 end)
    --controls.massRateContainer.Top:Set(function() return controls.massBG.Top() + 5 end)
    --controls.massRateContainer.Right:Set(controls.massDropdown.Left)
    controls.massDropdownTarget.Left:Set(controls.massDropdown.Left)
    controls.massDropdownTarget.Right:Set(controls.massDropdown.Right)
    controls.massDropdownTarget.Top:Set(controls.massBG.Top)
    controls.massDropdownTarget.Bottom:Set(controls.massBG.Bottom)
    --]]
    
    -- statusbar
    controls.massStatus:SetMinimumSlidePercentage(OIUtil.getValue('economy_barstep')/190)   --TODO some way to not hard code this! (it's the size of a tick in the status bar / size of the status bar)
	
	-- other
    controls.massIncome:DisableHitTest()
    controls.massExpense:DisableHitTest()
    controls.massDropdown:DisableHitTest()
    controls.massDropOver:DisableHitTest()
	controls.massRate:DisableHitTest()
	controls.massIncome.Depth:Set(function() return controls.group.Depth() + 10 end)
    controls.massExpense.Depth:Set(function() return controls.group.Depth() + 10 end)
    controls.massRate.Depth:Set(function() return controls.group.Depth() + 10 end)
    controls.massStorage.Depth:Set(function() return controls.group.Depth() + 10 end)
    
    -- warning
    controls.massWarning.Depth:Set(function() return controls.massLabel.Depth() + 10 end)
    controls.massWarning:Show()
    controls.massWarning:DisableHitTest()
    LayoutHelpers.AtCenterIn(controls.massWarning, controls.massLabel)
    
    
    ----------------------------------------------------------------------------
	-- energy setup
	----------------------------------------------------------------------------
	
	-- 1st level placement
	LayoutHelpers.AtRightTopIn(controls.energyBG, controls.group)
    LayoutHelpers.AtRightTopIn(controls.energyLabel, controls.energyBG, 2, 3)
    LayoutHelpers.AtRightTopIn(controls.energyStatus, controls.energyBG, 39, 7)
    LayoutHelpers.AtRightTopIn(controls.energyRateContainer, controls.energyBG, 236, 4)
    LayoutHelpers.AtRightTopIn(controls.energyDropdown, controls.energyBG, 303, 3)
    LayoutHelpers.AtCenterIn(controls.energyWarning, controls.energyLabel, 0, 0)
	
	-- 2nd level placement
    LayoutHelpers.AtCenterIn(controls.energyDropOver, controls.energyDropdown)
    LayoutHelpers.AtCenterIn(controls.energyRate, controls.energyRateContainer)
    LayoutHelpers.AtCenterIn(controls.energyIncome, controls.energyDropdown, -6, 0)
    LayoutHelpers.AtCenterIn(controls.energyExpense, controls.energyDropdown, 6, 0)
    controls.energyExpense:SetColor(OIUtil.getColor('economy_expense'))
    controls.energyIncome:SetColor(OIUtil.getColor('economy_income'))
    LayoutHelpers.CenteredBelow(controls.energyStorage, controls.energyStatus, 0)
	
	---[[
    -- dynamic placement
    --controls.energyRateContainer.Left:Set(function() return controls.energyStatus.Right() + 2 end)
    --controls.energyRateContainer.Top:Set(function() return controls.energyBG.Top() + 5 end)
    --controls.energyRateContainer.Right:Set(controls.energyDropdown.Left)
    controls.energyDropdownTarget.Left:Set(controls.energyDropdown.Left)
    controls.energyDropdownTarget.Right:Set(controls.energyDropdown.Right)
    controls.energyDropdownTarget.Top:Set(controls.energyBG.Top)
    controls.energyDropdownTarget.Bottom:Set(controls.energyBG.Bottom)
    --]]
	
	-- statusbar
    controls.energyStatus:SetMinimumSlidePercentage(OIUtil.getValue('economy_barstep')/190)   --TODO some way to not hard code this! (it's the size of a tick in the status bar / size of the status bar)
	
	-- other
    controls.energyIncome:DisableHitTest()
    controls.energyExpense:DisableHitTest()
    controls.energyDropdown:DisableHitTest()
    controls.energyDropOver:DisableHitTest()
    controls.energyDropOver:Hide()
	controls.energyRate:DisableHitTest()
	controls.energyIncome.Depth:Set(function() return controls.group.Depth() + 10 end)
    controls.energyExpense.Depth:Set(function() return controls.group.Depth() + 10 end)
    controls.energyRate.Depth:Set(function() return controls.group.Depth() + 10 end)
    controls.energyStorage.Depth:Set(function() return controls.group.Depth() + 10 end)
	
	-- warning
    controls.energyWarning.Depth:Set(function() return controls.energyLabel.Depth() + 10 end)
    controls.energyWarning:Show()
    controls.energyWarning:DisableHitTest()
    LayoutHelpers.AtCenterIn(controls.energyWarning, controls.energyLabel)
    
    
end


