
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')

function SetLayout()
    local GUI = import('/lua/ui/game/options.lua').GUI
    --local buttondata = import('/lua/ui/game/options.lua').buttonData
    local econControls = import('/lua/ui/game/economy.lua').controls
    
    local buttondata = {
        {id = 'exit_menu'},
        {id = 'objectives'},
        {id = 'score'},
        {id = 'inbox'},
        {id = 'diplomacy'},
        {id = 'pause', on = 'pause', off = 'play', ontooltip = 'options_Pause', offtooltip = 'options_Play', checkbox = true, glow = true},
    }
    
    local function CreateButton(data)
        local btn 
        if data.checkbox then
            btn = Checkbox(GUI.bg,
                OIUtil.getImage(data.on),
                OIUtil.getImage(data.off),
                OIUtil.getImage(data.on..'_mo'),
                OIUtil.getImage(data.off..'_mo'),
                OIUtil.getImage(data.on..'_mo'),
                OIUtil.getImage(data.off..'_mo'),
                "NO_SOUND", "UI_Options_Rollover")
            btn.glow = Bitmap(btn, UIUtil.UIFile('/game/options_btn/glow_bmp.dds'))
            LayoutHelpers.AtCenterIn(btn.glow, btn)
            btn.glow:SetAlpha(0)
            btn.glow:DisableHitTest()
        else
            btn = OIUtil.CreateButtonStd(GUI.bg, data.id, "", 12, 0, 0, "NO_SOUND", "UI_Options_Rollover")
        end
        btn.data = data
        return btn
    end
    if GUI.bg then GUI.bg:Destroy() GUI.bg = false end
    if not GUI.bg then
        --GUI.bg = Bitmap(GUI.parent, UIUtil.UIFile('/game/resources/center02_bmp_m.dds'))
        GUI.bg = Bitmap(GUI.parent, OIUtil.getImage('options_bg'))
    end
    ---[[
    LayoutHelpers.AtTopIn(GUI.bg, GUI.parent, 0)
    LayoutHelpers.ResetBottom(GUI.bg)
    LayoutHelpers.AtHorizontalCenterIn(GUI.bg, GUI.parent)
	--]]
	LayoutHelpers.AtTopIn(GUI.bg, GUI.parent, 0)
	
	--[[
    if GUI.leftBg then GUI.leftBg:Destroy() GUI.leftBg = false end
    if not GUI.leftBg then
        GUI.leftBg = Bitmap(GUI.parent, UIUtil.UIFile('/game/resources/center_bmp_l.dds'))
    end
    GUI.leftBg.Top:Set(function() return GUI.bg.Top() + 7 end)
    GUI.leftBg.Right:Set(function() return GUI.bg.Left() end)
    GUI.leftBg.Left:Set(function() return econControls.massBG.Right() - 17 end)
    GUI.leftBg.Width:Set(function() return GUI.leftBg.Right() - GUI.leftBg.Left() end)
    GUI.leftBg.Depth:Set(50)
    GUI.leftBg:SetTiled(true)

    if GUI.rightBg then GUI.rightBg:Destroy() GUI.rightBg = false end
    if not GUI.rightBg then
        GUI.rightBg = Bitmap(GUI.parent, UIUtil.UIFile('/game/resources/center_bmp_r.dds'))
    end
    GUI.rightBg.Top:Set(function() return GUI.bg.Top() + 7 end)
    GUI.rightBg.Left:Set(function() return GUI.bg.Right() end)
    GUI.rightBg.Right:Set(function() return econControls.energyBG.Left() + 15 end)
    GUI.rightBg.Width:Set(function() return GUI.rightBg.Right() - GUI.rightBg.Left() end)
    GUI.rightBg.Depth:Set(50)
    GUI.rightBg:SetTiled(true)
	--]]
	
    GUI.buttons = {}
    GUI.buttonsmfd = {}
    for i, v in buttondata do
        local index = i
        if not GUI.buttons[index] then
            GUI.buttons[index] = CreateButton(v)
        end
        if index == 1 then
            GUI.buttons[index].Left:Set(function() return GUI.bg.Left() + 5 end)
            GUI.buttons[index].Top:Set(function() return GUI.bg.Top() + 5 end)
        else
            LayoutHelpers.RightOf(GUI.buttons[index], GUI.buttons[index-1], 8)
        end
    end
    for i, v in GUI.buttonsmfd do
        if GUI.buttonsmfd[i] then
            GUI.buttonsmfd[i]:Destroy()
            GUI.buttonsmfd[i] = false
        end
    end
    if GUI.hideBtn then GUI.hideBtn:Destroy() GUI.hideBtn = false end
    if GUI.mfdCenterGroup then GUI.mfdCenterGroup:Destroy() GUI.mfdCenterGroup = false end
    GUI.bg:Show()
end


