
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')

function SetLayout()
    local controls = import('/lua/ui/game/queue.lua').controls
    
    controls.queueGroup.Height:Set(50)
    controls.queueGroup.Bottom:Set(function() return controls.controlClusterGroup.Bottom() + 3 end)
    controls.queueGroup.Left:Set(controls.mfdControl.Right)
    controls.queueGroup.Right:Set(function() return controls.ordersControl.Left() + 4 end)
    controls.queueGroup.Mini = function(state)
        controls.queueGroup:Show()
    end

    --controls.queueBGCapMin:SetTexture(UIUtil.SkinnableFile('/game/que_bmp/que-02_bmp_l.dds'))
    controls.queueBGCapMin:SetTexture(OIUtil.getImage('queue_h_left'), 2)
    LayoutHelpers.AtBottomIn(controls.queueBGCapMin, controls.queueGroup, 3)
    LayoutHelpers.AtLeftIn(controls.queueBGCapMin, controls.queueGroup, 0)
    LayoutHelpers.ResetTop(controls.queueBGCapMin)
    LayoutHelpers.ResetRight(controls.queueBGCapMin)

    --controls.queueBGCapMax:SetTexture(UIUtil.SkinnableFile('/game/que_bmp/que-02_bmp_r.dds'))
    controls.queueBGCapMax:SetTexture(OIUtil.getImage('queue_h_right'), 2)
    LayoutHelpers.AtBottomIn(controls.queueBGCapMax, controls.queueGroup, 3)
    LayoutHelpers.AtRightIn(controls.queueBGCapMax, controls.queueGroup, 2)
    LayoutHelpers.ResetTop(controls.queueBGCapMax)
    LayoutHelpers.ResetLeft(controls.queueBGCapMax)

    --controls.queueBGMiddle:SetTexture(UIUtil.SkinnableFile('/game/que_bmp/que-02_bmp_m.dds'))
    controls.queueBGMiddle:SetTexture(OIUtil.getImage('queue_h_bg'), 2)
    controls.queueBGMiddle.Left:Set(controls.queueBGCapMin.Right)
    controls.queueBGMiddle.Right:Set(controls.queueBGCapMax.Left)
    controls.queueBGMiddle.Top:Set(controls.queueBGCapMin.Top)
    LayoutHelpers.ResetWidth(controls.queueBGMiddle)
    controls.queueBGMiddle.Height:Set(controls.queueBGMiddle.BitmapHeight)
    LayoutHelpers.ResetBottom(controls.queueBGMiddle)
    controls.queueBGMiddle:SetTiled(true)

    controls.queueScrollBG.Depth:Set(function() return controls.queueBGCapMin.Depth() + 50 end)
    --controls.queueScrollBG:SetTexture(UIUtil.SkinnableFile('/game/que_bmp/scroll-back_bmp.dds'))
    controls.queueScrollBG:SetTexture(OIUtil.getImage('blank'))
    LayoutHelpers.RelativeTo(controls.queueScrollBG,
        controls.queueBGCapMin,
        UIUtil.SkinnableFile('/game/que_bmp/que_bmp_layout.lua'),
        "scroll-back_bmp",
        "que_bmp_l")--]]


    --[[LayoutHelpers.RelativeTo(controls.scrollQueueBackButton,
        controls.queueBGCapMin,
        UIUtil.SkinnableFile('/game/que_bmp/que_bmp_layout.lua'),
        "l_left_scroll",
        "que_bmp_l")--]]

    controls.scrollQueueBackButton:SetNewTextures(
    	OIUtil.getImage('scroll_left'),
        OIUtil.getImage('scroll_left'),
        OIUtil.getImage('scroll_left_mo'),
        OIUtil.getImage('scroll_left_dis')
    )
    LayoutHelpers.AtLeftTopIn(controls.scrollQueueBackButton, controls.queueBGCapMin, 103, 5)
    
    --[[LayoutHelpers.RelativeTo(controls.scrollQueueFwdButton,
        controls.queueBGCapMin,
        UIUtil.SkinnableFile('/game/que_bmp/que_bmp_layout.lua'),
        "l_right_scroll",
        "que_bmp_l")
    LayoutHelpers.ResetRight(controls.scrollQueueFwdButton) --]]
    
    controls.scrollQueueFwdButton:SetNewTextures(
    	OIUtil.getImage('scroll_right'),
        OIUtil.getImage('scroll_right'),
        OIUtil.getImage('scroll_right_mo'),
        OIUtil.getImage('scroll_right_dis')
    )
    LayoutHelpers.AtRightTopIn(controls.scrollQueueFwdButton, controls.queueBGCapMax, 7, 5) 
   
    
    controls.infiniteQueueToggle:SetNewTextures(
    	OIUtil.getImage('build_infinite'), 
        OIUtil.getImage('build_infinite_sel'),
        OIUtil.getImage('build_infinite_mo'),
        OIUtil.getImage('build_infinite_sel_mo'),
        OIUtil.getImage('build_infinite_dis'),
        OIUtil.getImage('build_infinite_dis')
    )
    
        
    controls.pauseToggle:SetNewTextures(
    	OIUtil.getImage('build_pause'),
        OIUtil.getImage('build_pause_sel'),
        OIUtil.getImage('build_pause_mo'),
        OIUtil.getImage('build_pause_sel_mo'),
        OIUtil.getImage('build_pause_dis'),
        OIUtil.getImage('build_pause_dis')
    )
    --LOG(OIUtil.getImage('build_pause'))
    
    --controls.infiniteQueueToggle.Top:Set(function() return controls.scrollQueueFwdButton.Bottom() - 0 end)
    -- place centered between queue scroll buttons
    --controls.infiniteQueueToggle.Left:Set(function() return controls.queueBGCapMin.Left() + 4 end)
    --controls.infiniteQueueToggle.Width:Set(30)
    
    --LayoutHelpers.RightOf(controls.pauseToggle, controls.infiniteQueueToggle)
    --controls.pauseToggle.Width:Set(30)
    LayoutHelpers.AtLeftTopIn(controls.infiniteQueueToggle, controls.queueBGCapMin, 51, 6)
    LayoutHelpers.AtLeftTopIn(controls.pauseToggle, controls.queueBGCapMin, 6, 6)
    
    
    
    controls.queueGrid:Destroy()
    controls.queueGrid = Grid(controls.queueBGMiddle, 62, 62)
    
    controls.queueGrid.Left:Set(function() return controls.queueBGMiddle.Left() - 28 end)
    controls.queueGrid.Right:Set(function() return controls.queueBGMiddle.Right() - 32 end)
    controls.queueGrid.Height:Set(64)
    LayoutHelpers.AtVerticalCenterIn(controls.queueGrid, controls.queueBGMiddle, -29)
    
    
    
    -- set scroll buttons over queue grid (!!! does not work yet, why?)
    controls.scrollQueueFwdButton.Depth:Set(function() return controls.queueGrid.Depth() + 10 end)
    controls.scrollQueueBackButton.Depth:Set(function() return controls.queueGrid.Depth() + 10 end)
    
    
    
    
end