
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')

function SetLayout()

    local controls = import('/lua/ui/game/selectionmanager.lua').controls
	local controls2 = import('/lua/ui/game/orders.lua').controls
	
    if not controls.panelmin then
        controls.panelmin = Bitmap(controls.controlClusterGroup)
        controls.panelmin.Depth:Set(600)
    end
    --controls.panelmin:SetTexture(UIUtil.UIFile('/game/unit_unselected/panel_bmp_l.dds'))
    controls.panelmin:SetTexture(OIUtil.getImage('selection_h_left'), 2)
    controls.panelmin.Left:Set(function() return controls.mfdControl.Right() + 96 end)
    --controls.panelmin.Top:Set(function() return controls.mfdControl.Top() + 5 end)
    controls.panelmin.Bottom:Set(function() return controls.controlClusterGroup.Bottom() end)
    controls.panelmin.Mini = nil
    
    if not controls.panelmax then
        controls.panelmax = Bitmap(controls.panelmin)
    end
    --controls.panelmax:SetTexture(UIUtil.UIFile('/game/unit_unselected/panel_bmp_r.dds'))
    controls.panelmax:SetTexture(OIUtil.getImage('selection_h_right'), 2)
    controls.panelmax.Right:Set(function() return controls.ordersControl.Left() + 2 end)
    controls.panelmax.Top:Set(controls.panelmin.Top)
    LayoutHelpers.ResetLeft(controls.panelmax)
    LayoutHelpers.ResetBottom(controls.panelmax)
    
    if not controls.panelstretch then
        controls.panelstretch = Bitmap(controls.panelmin)
    end
    --controls.panelstretch:SetTexture(UIUtil.UIFile('/game/unit_unselected/panel_bmp_m.dds'))
    controls.panelstretch:SetTexture(OIUtil.getImage('selection_h_bg'), 2)
    controls.panelstretch.Left:Set(function() return controls.panelmin.Right() end)
    controls.panelstretch.Right:Set(controls.panelmax.Left)
    controls.panelstretch.Top:Set(controls.panelmin.Top)
    controls.panelstretch.Bottom:Set(controls.panelmin.Bottom)
    
    
    if not controls.scrollup then
        controls.scrollup = Button(controls.panelmin)
    end
    
    --controls.scrollup:SetTexture(UIUtil.UIFile('/game/lg-vert_scr/arrow-up_scr_up.dds'))
    controls.scrollup:SetTexture(OIUtil.getImage('blank'))
    
    --[[controls.scrollup:SetNewTextures(UIUtil.UIFile('/game/lg-vert_scr/arrow-up_scr_up.dds')
        , UIUtil.UIFile('/game/lg-vert_scr/arrow-up_scr_down.dds')
        , UIUtil.UIFile('/game/lg-vert_scr/arrow-up_scr_over.dds')
        , UIUtil.UIFile('/game/lg-vert_scr/arrow-up_scr_dis.dds'))--]]
    controls.scrollup:SetNewTextures(
    	OIUtil.getImage('sm_scroll_left'),
    	OIUtil.getImage('sm_scroll_left'),
    	OIUtil.getImage('sm_scroll_left_mo'),
    	OIUtil.getImage('sm_scroll_left_dis')
    )
   
    if not controls.scrolldown then
        controls.scrolldown = Button(controls.panelmin)
    end
    --controls.scrolldown:SetTexture(UIUtil.UIFile('/game/lg-vert_scr/arrow-down_scr_up.dds'))
    controls.scrolldown:SetTexture(OIUtil.getImage('blank'))
    
    --[[controls.scrolldown:SetNewTextures(UIUtil.UIFile('/game/lg-vert_scr/arrow-down_scr_up.dds')
        , UIUtil.UIFile('/game/lg-vert_scr/arrow-down_scr_down.dds')
        , UIUtil.UIFile('/game/lg-vert_scr/arrow-down_scr_over.dds')
        , UIUtil.UIFile('/game/lg-vert_scr/arrow-down_scr_dis.dds'))--]]
    controls.scrolldown:SetNewTextures(
    	OIUtil.getImage('sm_scroll_right'),
    	OIUtil.getImage('sm_scroll_right'),
    	OIUtil.getImage('sm_scroll_right_mo'),
    	OIUtil.getImage('sm_scroll_right_dis')
    )
    
    --LayoutHelpers.AtLeftTopIn(controls.scrollup, controls.panelmin, 10, 50)    
    --LayoutHelpers.ResetRight(controls.scrolldown) 
    --LayoutHelpers.Below(controls.scrolldown, controls.scrollup, -5)
    LayoutHelpers.AtLeftTopIn(controls.scrollup, controls.panelmin, 8, 8)  
    LayoutHelpers.AtRightTopIn(controls.scrolldown, controls.panelmax, 8, 8)
    
    if controls.iconGrid then controls.iconGrid:Destroy() controls.iconGrid = false end
    if not controls.iconGrid then
        controls.iconGrid = Grid(controls.panelmin, 66, 66)
        controls.iconGrid:SetName("Selection Grid")
    end
    controls.iconGrid.Left:Set(function() return controls.panelmin.Left() end)
    controls.iconGrid.Top:Set(function() return controls.panelmin.Top() - 19 end)
    controls.iconGrid.Right:Set(function() return controls.panelmax.Right() - 35 end)
    controls.iconGrid.Bottom:Set(function() return controls.panelmin.Bottom() end)
end


