
local OIUtil = import('/mods/OllosInterface/libs/oiutil.lua')
local controls_const = import('/lua/ui/game/construction.lua').controls
local Prefs = import('/lua/user/prefs.lua')


function SetLayout()
    local controls = import('/lua/ui/game/unitview.lua').controls
    local numRoDisplayFields = import('/lua/ui/game/unitview.lua').numRoDisplayFields
    controls.rolloverGroup.Height:Set(50)
    controls.rolloverGroup.Depth:Set(function() return controls.parent.Depth() + 50 end)
    --controls.rolloverGroup.Bottom:Set(function() return controls.parent.Top() - 52 end)
    --controls.rolloverGroup.Left:Set(function() return controls.parent.Left() + 2 end)
    controls.rolloverGroup.Bottom:Set(function() return controls.parent.Top() end)
    controls.rolloverGroup.Left:Set(function() return controls_const.unitsBGTop.Right() end)
    
    
    if not controls.roBG then
        controls.roBG = Bitmap(controls.rolloverGroup)
    end
    --controls.roBG:SetTexture(UIUtil.UIFile('/game/unit-over/unit-over_bmp.dds'))
    controls.roBG:SetTexture(OIUtil.getImage('unitview_bg'), 2)
    controls.roBG.Bottom:Set(controls.rolloverGroup.Bottom)
    controls.roBG.Left:Set(controls.rolloverGroup.Left)
    
    --[[
    if not controls.roBG2 then
        controls.roBG2 = Bitmap(controls.rolloverGroup, UIUtil.UIFile('/game/border_bottom/back_brd_bl02.dds'))
    end
    controls.roBG2.Bottom:Set(function() return controls.rolloverGroup.Bottom() - 2 end)
    controls.roBG2.Left:Set(function() return controls.rolloverGroup.Left() - 1 end)
    controls.roBG2.Depth:Set(function() return controls.roBG.Depth() - 1 end)
    --]]

    if not controls.roIcon then
        controls.roIcon = Bitmap(controls.rolloverGroup)
    end
    controls.roIcon.Top:Set(function() return controls.rolloverGroup.Top() + 1 end)
    controls.roIcon.Left:Set(function() return controls.rolloverGroup.Left() + 4 end)
    controls.roIcon.Height:Set(46)
    controls.roIcon.Width:Set(46)
    
    if not controls.roStratIcon then
        controls.roStratIcon = Bitmap(controls.rolloverGroup)
    end
    controls.roStratIcon.Top:Set(function() return controls.roIcon.Top() + 8 end)
    controls.roStratIcon.Left:Set(function() return controls.roIcon.Right() + 10 end)
    --controls.roStratIcon.Width:Set(14)
    --controls.roStratIcon.Height:Set(14)
    

    local previousPip = false
    for i = 1, 3 do
        if not controls.roTechLevelPips[i] then
            controls.roTechLevelPips[i] = Bitmap(controls.rolloverGroup)
        end
        if i == 1 then
            controls.roTechLevelPips[i].Left:Set(function() return controls.roStratIcon.Right() + 4 end)
        else
            controls.roTechLevelPips[i].Left:Set(previousPip.Right)
        end
        controls.roTechLevelPips[i].Top:Set(function() return controls.roIcon.Top() + 17 end)
        controls.roTechLevelPips[i].Depth:Set(function() return controls.roIcon.Depth() + 1 end)
        previousPip = controls.roTechLevelPips[i]
    end

    if not controls.roHealthBar then
        controls.roHealthBar = StatusBar(controls.rolloverGroup, 0, 1, false, false, UIUtil.UIFile('/game/unit-over/health-bars-back-1_bmp.dds'), UIUtil.UIFile('/game/unit-over/bar01_bmp.dds'), true, "Unit RO Health Status Bar")
    end
    controls.roHealthBar.Left:Set(function() return controls.roIcon.Right() + 8 end)
    controls.roHealthBar.Right:Set(function() return controls.roHealthBar.Left() + 75 end)
    controls.roHealthBar.Bottom:Set(function() return controls.rolloverGroup.Bottom() - 20 end)
    controls.roHealthBar.Top:Set(function() return controls.roHealthBar.Bottom() - 4 end)
    controls.roHealthBar.Height:Set(function() return controls.roHealthBar.Bottom() - controls.roHealthBar.Top() end)
    controls.roHealthBar.Width:Set(function() return controls.roHealthBar.Right() - controls.roHealthBar.Left() end)

    if not controls.roProgBar then
        controls.roProgBar = StatusBar(controls.rolloverGroup, 0, 1, false, false, UIUtil.UIFile('/game/unit-over/health-bars-back-1_bmp.dds'), UIUtil.UIFile('/game/unit-over/bar01_bmp.dds'), true, "Unit RO Health Status Bar")
    end
    LayoutHelpers.Below(controls.roProgBar, controls.roHealthBar, 1)
    controls.roProgBar.Height:Set(controls.roHealthBar.Height)
    controls.roProgBar.Width:Set(controls.roHealthBar.Width)

    if not controls.roName then
        controls.roName = UIUtil.CreateText(controls.rolloverGroup, "", 12, UIUtil.bodyFont)
    end
    --controls.roName.Top:Set(function() return controls.roIcon.Top() + 0 end)
    --controls.roName.Left:Set(function() return controls.roIcon.Right() + 65 end)
    controls.roName.Top:Set(function() return controls.roBG.Top() + 6 end)
    controls.roName.Left:Set(function() return controls.roBG.Left() + 115 end)
    controls.roName.Right:Set(function() return controls.roBG.Right() - 10 end)
    controls.roName:SetClipToWidth(true)
    controls.roName:SetDropShadow(true)
    
    local prevVetIcon = false
    for i=1, 5 do
        local index = i
        if not controls.roVeteranIcons[i] then
            controls.roVeteranIcons[index] = Bitmap(controls.rolloverGroup)
        end
        if index == 1 then
            controls.roVeteranIcons[index].Left:Set(function() return controls.roIcon.Right() + 1 end)
        else
            LayoutHelpers.RightOf(controls.roVeteranIcons[index], controls.roVeteranIcons[index-1], -3)
        end
        controls.roVeteranIcons[index].Bottom:Set(function() return controls.roStratIcon.Top() end)
        controls.roVeteranIcons[index]:SetTexture(UIUtil.UIFile('/game/veteran-logo_bmp/uef-veteran_bmp.dds'))
        controls.roVeteranIcons[index]:Hide()
        prevVetIcon = controls.roVeteranIcons[index]
    end
    
    if not controls.roId then
        controls.roId = UIUtil.CreateText(controls.rolloverGroup, "", 12, UIUtil.bodyFont)
    end
    controls.roId.Top:Set(function() return controls.roName.Bottom() + 12 end)
    LayoutHelpers.AtHorizontalCenterIn(controls.roId, controls.roHealthBar)
    controls.roId:SetDropShadow(true)


    if not controls.roHealth then
        controls.roHealth = UIUtil.CreateText(controls.roHealthBar, "", 10, UIUtil.bodyFont)
    end
    LayoutHelpers.AtHorizontalCenterIn(controls.roHealth, controls.roHealthBar)
    controls.roHealth.Top:Set(function() return controls.roHealthBar.Bottom() + 3 end)
    controls.roHealth.Depth:Set(function() return controls.roHealthBar.Depth() + 10 end)
    controls.roHealth:SetDropShadow(true)

    if not controls.roDisplay['mass'] then
        controls.roDisplay['mass'] = {}
        controls.roDisplay['mass'].text = UIUtil.CreateText(controls.rolloverGroup, "", 12, UIUtil.bodyFont)
        controls.roDisplay['mass'].icon = Bitmap(controls.rolloverGroup)
    end
    --controls.roDisplay['mass'].icon.Left:Set(function() return controls.roHealthBar.Right() + 9 end)
    --controls.roDisplay['mass'].icon.Top:Set(function() return controls.roHealthBar.Top() end)
    controls.roDisplay['mass'].icon.Left:Set(function() return controls.roBG.Left() + 144 end)
    controls.roDisplay['mass'].icon.Top:Set(function() return controls.roBG.Top() + 29 end)
    controls.roDisplay['mass'].text.Left:Set(function() return controls.roDisplay['mass'].icon.Right()  end)
    LayoutHelpers.AtVerticalCenterIn(controls.roDisplay['mass'].text, controls.roDisplay['mass'].icon, 1)

    if not controls.roDisplay['energy'] then
        controls.roDisplay['energy'] = {}
        controls.roDisplay['energy'].text = UIUtil.CreateText(controls.rolloverGroup, "", 12, UIUtil.bodyFont)
        controls.roDisplay['energy'].icon = Bitmap(controls.rolloverGroup)
    end
    controls.roDisplay['energy'].icon.Left:Set(function() return controls.roDisplay['mass'].icon.Right() + 43 end)
    controls.roDisplay['energy'].icon.Top:Set(controls.roDisplay['mass'].icon.Top)
    controls.roDisplay['energy'].text.Left:Set(function() return controls.roDisplay['energy'].icon.Right() end)
    LayoutHelpers.AtVerticalCenterIn(controls.roDisplay['energy'].text, controls.roDisplay['energy'].icon, 1)

    for i=1, numRoDisplayFields do
        if not controls.roDisplay[i] then
            controls.roDisplay[i] = {}
            controls.roDisplay[i].text = UIUtil.CreateText(controls.rolloverGroup, "", 12, UIUtil.bodyFont)
            controls.roDisplay[i].icon = Bitmap(controls.rolloverGroup)
        end
        if i == 1 then
            controls.roDisplay[1].icon.Left:Set(function() return controls.roDisplay['energy'].icon.Right() + 44 end)
        else
            local prevControl = controls.roDisplay[i - 1].text
            controls.roDisplay[i].icon.Left:Set(function() return prevControl.Right() + 6 end)
        end
        LayoutHelpers.AtVerticalCenterIn(controls.roDisplay[i].icon, controls.roDisplay['mass'].icon)
        controls.roDisplay[i].text.Left:Set(function() return controls.roDisplay[i].icon.Right() + 2 end)
        LayoutHelpers.AtVerticalCenterIn(controls.roDisplay[i].text, controls.roDisplay[i].icon, 1)
    end

    if not controls.roFocusBG then
        --controls.roFocusBG = Bitmap(controls.rolloverGroup, UIUtil.UIFile('/game/unit-over/unit-over-build_bmp.dds'))
        controls.roFocusBG = Bitmap(controls.rolloverGroup)
        controls.roFocusBG:SetTexture(OIUtil.getImage('unitview_build_bg'), 2)
    end
    controls.roFocusBG.Top:Set(function() return controls.roBG.Top() end)
    controls.roFocusBG.Left:Set(function() return controls.roBG.Right() end)

    if not controls.roFocusIcon then
        controls.roFocusIcon = Bitmap(controls.rolloverGroup)
    end
    controls.roFocusIcon.Top:Set(controls.roIcon.Top)
    controls.roFocusIcon.Left:Set(function() return controls.roFocusBG.Left() + 3 end)
    controls.roFocusIcon.Height:Set(46)
    controls.roFocusIcon.Width:Set(46)
    controls.roFocusIcon.Depth:Set(function() return controls.roFocusBG.Depth() + 1 end)
    
    if not controls.roFocusHealthPercent then
        controls.roFocusHealthPercent = UIUtil.CreateText(controls.rolloverGroup, "", 14, UIUtil.bodyFont)
    end
    controls.roFocusHealthPercent.Bottom:Set(function() return controls.roFocusIcon.Bottom() - 3 end)
    controls.roFocusHealthPercent.Right:Set(function() return controls.roFocusIcon.Right() + 41 end)
    LayoutHelpers.ResetLeft(controls.roFocusHealthPercent)
    controls.roFocusHealthPercent:SetDropShadow(true)
    controls.roFocusHealthPercent.Depth:Set(function() return controls.roFocusBG.Depth() + 1 end)
    
    if not controls.roFocusHealthBar then
        controls.roFocusHealthBar = StatusBar(controls.rolloverGroup, 0, 1, false, false, OIUtil.getImage('blank'), UIUtil.UIFile('/game/unit-over/bar01_bmp.dds'), true, "Unit RO Health Status Bar")
    end
    controls.roFocusHealthBar.Left:Set(function() return controls.roFocusHealthPercent.Right() + 10 end)
    controls.roFocusHealthBar.Right:Set(function() return controls.roFocusHealthBar.Left() + 184 end)
    controls.roFocusHealthBar.Bottom:Set(function() return controls.roFocusHealthPercent.Bottom() - 12 end)
    controls.roFocusHealthBar.Top:Set(function() return controls.roFocusHealthBar.Bottom() - 5 end)
    controls.roFocusHealthBar.Height:Set(function() return controls.roFocusHealthBar.Bottom() - controls.roFocusHealthBar.Top() end)
    controls.roFocusHealthBar.Width:Set(function() return controls.roFocusHealthBar.Right() - controls.roFocusHealthBar.Left() end)
    controls.roFocusHealthBar.Depth:Set(function() return controls.roFocusBG.Depth() + 1 end)
    controls.roFocusHealthBar._bar.Depth:Set(function() return controls.roFocusBG.Depth() + 2 end)

    if not controls.roFocusName then
        controls.roFocusName = UIUtil.CreateText(controls.rolloverGroup, "", 12, UIUtil.bodyFont)
    end
    controls.roFocusName.Top:Set(function() return controls.roFocusBG.Top() + 6 end)
    controls.roFocusName.Left:Set(function() return controls.roFocusIcon.Right() + 10 end)
    controls.roFocusName:SetDropShadow(true)
    controls.roFocusName.Depth:Set(function() return controls.roFocusBG.Depth() + 1 end)

    controls.rolloverGroup:DisableHitTest(true)
    
    controls.roBG:DisableHitTest(true)
    controls.rolloverGroup:DisableHitTest(true)
    
    if Prefs.GetOption('oi_unitview_abilities') == 1 then
	    if not controls.AbilityList then
	        controls.AbilityList = CreateTextbox(controls.roBG)
	    end
	    controls.AbilityList.Left:Set(function() return controls.roBG.Left() + 15 end)
	    controls.AbilityList.Bottom:Set(function() return controls.roBG.Top() - 14 end)
	    controls.AbilityList.Width:Set(20)
	    LayoutAbilityBox(controls.AbilityList)
	else 
		controls.AbilityList = false
	end
    
end

function LayoutAbilityBox(group)
    group.bgmidmiddle.Left:Set(group.Left)
    group.bgmidmiddle.Bottom:Set(group.Bottom)
    
    group.bgtopleft.Right:Set(group.bgmidmiddle.Left)
    group.bgtopleft.Bottom:Set(group.bgmidmiddle.Top)
    group.bgtopright.Left:Set(group.bgmidmiddle.Right)
    group.bgtopright.Bottom:Set(group.bgmidmiddle.Top)
    
    group.bgbotleft.Right:Set(group.bgmidmiddle.Left)
    group.bgbotleft.Top:Set(group.bgmidmiddle.Bottom)
    group.bgbotright.Left:Set(group.bgmidmiddle.Right)
    group.bgbotright.Top:Set(group.bgmidmiddle.Bottom)
     
    group.bgtopmiddle.Bottom:Set(group.bgmidmiddle.Top)
    group.bgtopmiddle.Left:Set(group.bgmidmiddle.Left)
    group.bgtopmiddle.Right:Set(group.bgmidmiddle.Right)
    group.bgbotmiddle.Top:Set(group.bgmidmiddle.Bottom)
    group.bgbotmiddle.Left:Set(group.bgmidmiddle.Left)
    group.bgbotmiddle.Right:Set(group.bgmidmiddle.Right)
    
    group.bgmidleft.Bottom:Set(group.bgmidmiddle.Bottom)
    group.bgmidleft.Top:Set(group.bgmidmiddle.Top)
    group.bgmidleft.Right:Set(group.bgmidmiddle.Left)
    group.bgmidright.Bottom:Set(group.bgmidmiddle.Bottom)
    group.bgmidright.Top:Set(group.bgmidmiddle.Top)
    group.bgmidright.Left:Set(group.bgmidmiddle.Right)
        
    LayoutHelpers.AtLeftTopIn(group.Value[1], group.bgmidmiddle, -5, -5)
end

function CreateTextbox(parent)
    local group = Group(parent)
    
	group.bgtopleft = Bitmap(group)
    group.bgtopmiddle = Bitmap(group)
    group.bgtopright = Bitmap(group)
    
    group.bgmidleft = Bitmap(group)
    group.bgmidmiddle = Bitmap(group)
    group.bgmidright = Bitmap(group)
    
    group.bgbotleft = Bitmap(group)
    group.bgbotmiddle = Bitmap(group)
    group.bgbotright = Bitmap(group)
    
    group.bgtopleft:SetTexture(OIUtil.getImage('text_topleft'))
    group.bgtopmiddle:SetTexture(OIUtil.getImage('text_top'))
    group.bgtopright:SetTexture(OIUtil.getImage('text_topright'))
    
    group.bgmidleft:SetTexture(OIUtil.getImage('text_left'))
    group.bgmidmiddle:SetTexture(OIUtil.getImage('text_bg'))
    group.bgmidright:SetTexture(OIUtil.getImage('text_right'))
    
    group.bgbotleft:SetTexture(OIUtil.getImage('text_bottomleft'))
    group.bgbotmiddle:SetTexture(OIUtil.getImage('text_bottom'))
    group.bgbotright:SetTexture(OIUtil.getImage('text_bottomright'))


    group.Value = {}
    group.Value[1] = UIUtil.CreateText( group, "", 12, UIUtil.bodyFont)
    
    return group
end